//popisna statistika

function [vystup]=modus(x)
    pause
    //vystup ... hodnota modu
    //x... vektor vstupnich hodnot
    if size(x,1)==2 then
        kde=find(x(2,:)==max(x(2,:)));
        vystup=x(1,kde);
    else
        setrizena_data=gsort(x,'lc','i');
        cetnosti=[setrizena_data(1,1);1];
        a=1;
        for i=2:1:size(setrizena_data,2)
            if cetnosti(1,a)== setrizena_data(1,i) then
                cetnosti(2,a)=cetnosti(2,a)+1;
            else
                a=a+1;
                cetnosti(:,a)=[setrizena_data(1,i);1];                                
            end          
        end
        kde=find(cetnosti(2,:)==max(cetnosti(2,:)));
        vystup=cetnosti(1,kde);
    end
endfunction

function [per]=percentil(x,r)
    //per ... vysledek percentilu
    //x ... vstupni vektor dat
    //r ... hodnota percentilu
    setrizena_data=gsort(x,'lc','i');
    [m n]=size(setrizena_data); //zjisteni poctu prvku
    if m>n & n==1 then  //test,zda se nejedna o sloupcovy vektor
        n=m;
    end
    if r<0 | r>1 then  //hodnota percentilu musi byt mezi 0 a 1
        disp('Percentil musi byt mezi hodnotou 0 a 1.')
    else
        k=n*r; //hledani prvku v usporadanem vektoru je pocet prvku *percentil
        if k-floor(k)~=0 then   //hledame-li z licheho poctu prvku (s ohledem na r)
            per=setrizena_data(round(n*r));
        else  //hledame-li ze sudeho poctu prvku (s ohledem na r)
            per=(setrizena_data(k)+setrizena_data(k+1))/2   
        end
    end
endfunction

function [vystup]=mezikvartilove_rozpeti(x)
    //vystup ... hodnota mezikvartilového rozpětí
    //x ... vstupní vektor dat
    dolni_kvartil=percentil(x,0.25);
    horni_kvartil=percentil(x,0.75);
    vystup=horni_kvartil-dolni_kvartil;
endfunction

function [vystup]=kovariance(X,Y)
//    A=cov(X,Y);
//    vystup=A(2,1);
    vystup=cov(X(:),Y(:))(1,2);
endfunction

function [vystup]=kovariancni_matice(X,Y)
    //vystup ... kovarianční matice
    //X ... hodnoty náhodné veličiny X
    //Y ... hodnoty nádhoné veličiny Y
    vystup=cov{X,Y};
endfunction

function [vystup]=korelace(X,Y)
    //vystup ... korelační koeficient
    //X ... hodnoty náhodné veličiny X
    //Y ... hodnoty nádhoné veličiny Y
    vystup=kovariance(X,Y)/(sqrt((variance(X))*(variance(Y))));
endfunction

function [vystup]=variacni_rozpeti(x)
    //vystup ... hodnota variacniho rozpeti
    //x ... hodnoty nahodné veličiny X
    vystup=max(x)-min(x);
endfunction
