//anova - one factor
function pv=anova_1(x)
  //pv... p-value
  //x ... list of variables or data matrix

  // if t is data matrix
  if type(x)~=15
    Lm=mat2list(x);
    x=Lm;
  end

  a=length(x);
  for i=1:a
    n(i)=max(size(x(i)));
  end
  df=n-1;
  s=0;
  for i=1:a
    mx(i)=mean(x(i));
    s=s+n(i)*mx(i);
  end
  xx=s/sum(n);
  ssb=0; ssw=0;
  for i=1:a
    ssb=ssb+n(i)*(mx(i)-xx)^2;
    ssw=ssw+df(i)*variance(x(i));
  end
  ssc=ssb+ssw;
  dfb=a-1;
  dfw=sum(df);
  dfc=dfb+dfw;
  msb=ssb/dfb;
  msw=ssw/dfw;
  T=msb/msw;
  [P,pv]=cdff("PQ",T,dfb,dfw);
endfunction

//anova - two factors
function [pv_col, pv_row]=anova_2(s)
  //pv_col ... p-value for columns (1. faktor)
  //pv_row ... p-value for rows    (2. faktor)
  //s ... matrix of data
  
  if type(s)==15                     // if s is set as a list
    nL=length(s);
    for i=1:nL
      M(:,i)=s(i)(:);
    end
    s=M;
  end

  [a b]=size(s);                      // poč. řádku, poč. sloupců
  ms1=mean(s,1);                      // řádek průměrů sloupců
  ms2=mean(s,2);                      // sloupec průměrů řádků
  ss =mean(s(:));                     // celkový průměr
  S1 =a*sum((ms1-ss).^2);             // suma odchylek řádků
  S2 =b*sum((ms2-ss).^2);             // suma odchylek sloupců
  sh =ones(a,1)*ms1+ms2*ones(1,b)-ss; // predikce
  sx =s-sh;                           // rezidua
  SR =sum((sx(:)).^2);                // suma reziduálních čtverců
  df1=b-1;                            // stupně volnosti pro ř.
  df2=a-1;                            // stupně volnosti pro sl.
  dfR=df1*df2;                        // reziduální stupně volnosti
  MS1=S1/df1;                         // efekt sloupců
  MS2=S2/df2;                         // efekt řádků
  MSR=SR/(df1*df2);                   // reziduální efekt
  T1 =MS1/MSR;                        // stat. pro sloupce
  T2 =MS2/MSR;                        // stat. pro řádky
  [P,pv_col]=cdff("PQ",T1,df1,dfR);   // p-value pro sloupce
  [P,pv_row]=cdff("PQ",T2,df2,dfR);   // p-value pro řádky
endfunction


